/*	Copyright  (c)	Günter Woigk 1999 - 2007
  					mailto:kio@little-bat.de

	This file is free software

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission. The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.

 	error handling

note:
	include errors.cpp:  support for cstrings only, does not require class String
	_or_    serrors.cpp: support for cstrings and class String strings


	1999-01-01	first work on this file
	1999-09-16	added string version
	2001-02-17	added possibility to #include custom error file
	2001-11-09	added support for class String, renamed ErrorText() to ErrorStr() / ErrorString()
*/

#define	SAFE	1
#define	LOG		0

#include 	"kio.h"
#include	"errors.h"
INIT_MSG;

char custom_errmsg[256];
bool custom_error = 0;

cstr ETEXT[] = {
#define		EMAC(a,b)	b
#include	"error_emacs.h"
};

const nothrow_t nothrow={};


// get default error text for error
// does not call any memory allocating function
//
cstr ErrorStr( int err )
{
	if (err==0)  return "no error";
	if (err==-1) return "unknown error (-1)";
	if (err>=EBAS && err<EBAS+(int)NELEM(ETEXT)) return ETEXT[err-EBAS];
	return strerror(err);
}


// get error text for current error
//
cstr ErrorStr()
{
	return custom_error ? custom_errmsg : ErrorStr(errno);
}


// set error to custom error message
//
void ForceError ( int err, cstr msg )
{
	strncpy(custom_errmsg,msg,255);
	custom_error = 1;
	errno = err;
}

void SetError ( int err, cstr msg )
{
	if(!errno) ForceError( err, msg );
}

void ForceError ( cstr msg )
{
	ForceError( customerror,msg );
}

void SetError ( cstr msg )
{
	if(!errno) ForceError( customerror, msg );
}
















